/*********************************************************************
 * 'PataCal 0.2.0: The 'PataPhysical calendar
 * (C) Jrme Euzenat, 2000
 *
 * Parts:
  ********************************************************************/

#include "patacal.h"
#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>

#define CREATOR		'PtCl'

#define TRUE 1
#define FALSE 0
#define MAIN 0

#define HUNDAYI 6
#define BISEXT 1
#define MAXDATE 256

#define ComputeYear(yy) yy+31
// yy+1904-31
#define mlen(x) ( x == HUNDAYI || ( leap && x == BISEXT) )?29:28

DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
    EventType evt;
    Word error, prefsSize;
    DateType DisplayDate;
    
    if (cmd != sysAppLaunchCmdNormalLaunch) return FALSE;

    FrmGotoForm(mainForm);

    while (TRUE)
    {
	EvtGetEvent(&evt, evtWaitForever);
	if (SysHandleEvent(&evt)) continue;
	if (MenuHandleEvent(NULL, &evt, &error)) continue;

	switch (evt.eType)
	{
	  case ctlSelectEvent:
	    switch (evt.data.ctlSelect.controlID)
	    {
	      case okAboutBtn:
		FrmGotoForm(mainForm);
		break;

	      case dateBtn:
		{ Int dd, mm, yy;
	    		DateSecondsToDate(TimGetSeconds(), &DisplayDate);
			dd = DisplayDate.day;
			mm = DisplayDate.month;
			yy = DisplayDate.year + 1904;
                   	SelectDay(selectDayByDay,&mm, &dd, &yy, "Select Date");
			DisplayDate.year = yy - 1904;
			DisplayDate.month = mm;
			DisplayDate.day = dd;
			ComputePataData(DisplayDate);
			FrmDrawForm(FrmGetActiveForm());};
		break;

	      case chooseBtn:
		{ FrmPopupForm(choosePDateForm); };
		break;

	      case befBtn:
		{ if(DisplayDate.day!=1) DisplayDate.day=DisplayDate.day-1;
		  else if(DisplayDate.month!=1) {
			   DisplayDate.month=DisplayDate.month-1;
			   DisplayDate.day=28; // False
		  } else {
                     DisplayDate.year=DisplayDate.year-1;
		     DisplayDate.month=1; // False
		     DisplayDate.day=28; // False
                  };
		  ComputePataData(DisplayDate);}
		break;

	      default:
		FrmHandleEvent(FrmGetActiveForm(), &evt);
	    }
	    break;

	  case frmLoadEvent:
	    FrmSetActiveForm(FrmInitForm(evt.data.frmLoad.formID));
	    break;

	  case frmOpenEvent:
	    if ( evt.data.frmOpen.formID == mainForm){
		DateSecondsToDate(TimGetSeconds(), &DisplayDate);
		ComputePataData(DisplayDate);};
	    FrmDrawForm(FrmGetActiveForm());
	    break;

	  case menuEvent:
	    switch ( evt.data.menu.itemID ) {
		case menuItemAbout: FrmPopupForm(aboutForm) ; break;
		case menuItemCopy: {
	 	      FormPtr f = FrmGetActiveForm() ;
		      //--
		      /* This can only work if I select the content of the field... */
		      FieldPtr field = (FieldPtr)FrmGetObjectPtr(f, FrmGetObjectIndex(f, dateField));
		      FldSetSelection( field, 0, FldGetTextLength( field ));
        	      FldCopy(field);
		      FldSetSelection( field, 0, 0);
			break;}
		default: FrmHandleEvent(FrmGetActiveForm(), &evt);
		}
	    break;

	  case appStopEvent:
	    FrmCloseAllForms();
	    return FALSE;

	  default:
	    FrmHandleEvent(FrmGetActiveForm(), &evt);
	}
    }
    return FALSE;
}

void SetText(FieldPtr fieldPtr, CharPtr text)
{
    VoidHand textH;
    CharPtr textP;

    textH = MemHandleNew(StrLen(text)+1);
    if (textH == NULL) return;
    textP = MemHandleLock(textH);
    StrCopy(textP, text);
    MemHandleUnlock(textH);
    FldSetTextHandle(fieldPtr, (Handle)textH);
}

int ComputePataData(DateType date)
{
    FormPtr f = FrmGetActiveForm();
    CharPtr str;
    DateType dt;
    Boolean leap;
    ULong dy;
    int mm, dd, yy;
    int i,j=0;
    static char *mois[13] = {
        "dcervelage",
        "gueules",
        "pdale",
        "clinamen",
        "palotin",
        "merdre",
        "gidouille",
        "tatane",
        "phalle",
        "absolu",
        "haha",
        "as",
        "sable"
    };
    
#ifdef SAINTS
#include "patasts.h"
#endif

    // Leap year?
    yy = date.year+1904;
    leap = ( !(yy%4) && ( yy%100 || !(yy%400) ));
    // First line
    str = (CharPtr)MemPtrNew(MAXDATE);
    DateToDOWDMFormat(date.month,date.day,yy,TRUE,str);
    SetText((FieldPtr)FrmGetObjectPtr(f, FrmGetObjectIndex(f, dayField)), str);
    // adjust Pataphysical year (begins the 8th of september 1873)
    yy = ComputeYear(date.year); 
    if( date.month > 9 || (date.month==9 && date.day>7)) yy++;
    // Days in the year
    dt.year = date.year; dt.month = 1; dt.day = 1;
    dy = DateToDays(date) - DateToDays(dt) + 1;
    // Month and Day
    if ( dy<363 || (dy==363 && leap)) {
	i = dy + 3; // The 3 days of end of the previous year
	while ( i > (mlen(j)) ) { i=i-(mlen(j)); j++;};
    } else { i = dy - (leap?363:362); };

    StrCopy(str,"");
    StrIToA(str + StrLen(str), i);
    StrCat(str, " ");
    StrCat(str,  mois[j]);
    StrCat(str, " ");
    StrIToA(str + StrLen(str),  yy);
    SetText((FieldPtr)FrmGetObjectPtr(f, FrmGetObjectIndex(f, dateField)), str);
#ifdef SAINTS
    if ( leap && dy>=23 && dy<=29 ) {
	if ( dy==23 ) StrCopy(str,"Hunyadi, Mouvement perptuel");
	else StrCopy(str,saints[dy]);
    } else {
      StrCopy(str,saints[dy-1]);
    };
    SetText((FieldPtr)FrmGetObjectPtr(f, FrmGetObjectIndex(f, saintField)), str);
#endif
    MemPtrFree(str);
    return TRUE;
}

